schematicsState = true;

local backdrop ={bgFile = "Interface\\Garrison\\GarrisonMissionUIInfoBoxBackgroundTile.blp", tile = false, tileSize = 70};

local backdrop_check = {bgFile = "Interface\\RAIDFRAME\\ReadyCheck-Ready.blp", tile = false};

local tomtom_loaded = IsAddOnLoaded("tomtom");

local s_check ={};

local s_texture = {};

SLASH_WATCHTOWER1 = "/ssi";
SlashCmdList["WATCHTOWER"] = function()
	S_Graph:Show();
end

function schematicsFrame()

	

	if S_Graph == nil then
		
		local S_Graph = CreateFrame("Frame", "S_Graph", UIParent, "ButtonFrameTemplate");
		S_Graph:Hide();
		S_Graph:SetPoint("Center");
		S_Graph:SetSize(576,476);
		S_Graph:EnableMouse(true);
		MakeMovable(S_Graph);
		S_Graph:SetFrameStrata("HIGH");
		S_Graph:CreateFontString("S_Title","ARTWORK" ,"GameFontNormal");
		S_Title:SetText("Ship Schematics Info");
		S_Title:SetPoint("TOP", 12, -5);
		
		S_Graph:CreateTexture("SSI_Icon", "ARTWORK");
		SSI_Icon:SetWidth(60);
		SSI_Icon:SetHeight(60);
		SSI_Icon:SetPoint("TOPLEFT", -6, 7);
		SetPortraitToTexture(SSI_Icon, "Interface\\Icons\\TEMP.blp")
		
		local close_Button = CreateFrame("Button", "SSI_Close", S_Graph, "MagicButtonTemplate");
		local reset_Button = CreateFrame("Button", "SSI_Reset", S_Graph, "MagicButtonTemplate");
		
		close_Button:SetText("Close");
		close_Button:SetPoint("BOTTOMRIGHT", S_Graph, "BOTTOMRIGHT", -6, 4);
		close_Button:SetScript("OnClick", function()
			S_Graph:Hide();
		end)
		
		
		reset_Button:SetText("Reset");
		reset_Button:SetPoint("TOPRIGHT", close_Button, "TOPLEFT");
		reset_Button:SetScript("OnClick", function()
			SDB_reset();
		end)
		
		for i = 1, #SchematicsDB.patterns do
			
			
			local frame = CreateFrame("Frame", SchematicsDB.patterns[i].name, S_Graph, "ThinBorderTemplate");
			frame:SetSize(270, 70);
			frame:SetPoint(SchematicsDB.patterns[i].self_anchor, SchematicsDB.patterns[i].relativeto, SchematicsDB.patterns[i].parent_anchor, SchematicsDB.patterns[i].x_offset, SchematicsDB.patterns[i].y_offset);
			frame:SetBackdrop(backdrop);
			
			s_texture[i] = frame:CreateTexture(nil, "ARTWORK",nil, 7);
			s_texture[i]:SetAllPoints(frame);
			s_texture[i]:SetTexture(0.0,0.8,0.0,0.2);
			
			
			local icon = CreateFrame("Button", "button_" .. SchematicsDB.patterns[i].name, frame);
			icon:SetNormalTexture(SchematicsDB.patterns[i].icon);
			icon:SetSize(60,60);
			icon:SetPoint("Left", frame, "Left", 5, 0);
			
			local name_string = frame:CreateFontString(nil, "ARTWORK" ,"GameFontNormal");
			name_string:SetPoint("TOPLEFT", icon, "TOPRIGHT", 10, 0);
			name_string:SetText(SchematicsDB.patterns[i].title);
			
			
			icon:SetScript("OnClick", function()
				
				if SchematicsDB.patterns[i].status == false then
					SchematicsDB.patterns[i].status = true;
				else
					SchematicsDB.patterns[i].status = false;
				end
				
				s_updater();
				
			end)
			
			
			local drop_string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall");
			drop_string:SetPoint("TOPLEFT", name_string, "BOTTOMLEFT", 0, -3);
			drop_string:SetText("Dropped by: " .. SchematicsDB.patterns[i].npc);
			drop_string:SetTextColor(0,1,1,1);
			
			if SchematicsDB.patterns[i].loc_x ~= nil then
				local coord_string = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall");
				coord_string:SetPoint("TOPLEFT", drop_string, "BOTTOMLEFT", 0, -3);
				coord_string:SetText("LOC: " .. SchematicsDB.patterns[i].loc_x .. "," .. SchematicsDB.patterns[i].loc_y);
				coord_string:SetTextColor(0,1,1,1);
				
				local s_waypoint = CreateFrame("Button", SchematicsDB.patterns[i].name ..  "_waybutton", frame, "UIPanelButtonTemplate, SecureActionButtonTemplate");
				s_waypoint:SetText("Waypoint");
				s_waypoint:SetSize(75,25);
				s_waypoint:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -5, 5);
				if tomtom_loaded == false then
					s_waypoint:Hide();
				end
				s_waypoint:SetAttribute("type", "macro");
				s_waypoint:SetAttribute("macrotext", SchematicsDB.patterns[i].macrotext);
				
				
			end
			
			
			s_check[i] = CreateFrame("Frame", nil, frame);
			s_check[i]:SetPoint("CENTER");
			s_check[i]:SetSize(60,60);
			s_check[i]:SetBackdrop(backdrop_check);
			
				
			
		end
		
		
	end

	s_updater();

end

function SDB_reset()

	for i = 1, #SchematicsDB.patterns do
		SchematicsDB.patterns[i].status = false;
	end
	
	s_updater();
	
end


function s_updater()
	for i = 1, #SchematicsDB.patterns do
	
		if SchematicsDB.patterns[i].status == false then
			s_check[i]:Hide();
			s_texture[i]:Hide();
		else
			s_check[i]:Show();
			s_texture[i]:Show();
		end
	
	end
end