watchtowerState = true;

WATCHTOWER_FOLLOWER_STATE = "active";

local faction = UnitFactionGroup("player");


function watchtowerFrame()
	
	watchtower_toggle_button();
	
	if WT_Graph == nil then
		
		local containers = WatchtowerDB.containers;
		local backdrop = {bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 32};
		local x_size, y_size = GarrisonMissionFrame:GetSize();
		GarrisonMissionFrame:SetPoint("CENTER", UIParent, "CENTER", -200, 0 );
		
		local graph = CreateFrame("Frame", "WT_Graph", GarrisonMissionFrame, "GarrisonUITemplate");
		graph:SetSize(420, y_size);
		graph:SetPoint("LEFT", GarrisonMissionFrame, "RIGHT", 1, 0);
		graph:EnableMouse(true);
		graph.CloseButton:Hide();
		graph:CreateFontString("WT_Title","ARTWORK" ,"GameFontNormal");
		WT_Title:SetText("Watchtower");
		WT_Title:SetPoint("TOP", 0, -5);
		graph:CreateFontString("WT_Footer", "ARTWORK", "GameFontNormalSmall");
		WT_Footer:SetText("Lot20Syndicate");
		WT_Footer:SetPoint("BOTTOMRIGHT", -50, 5);
		
		local greybox = CreateFrame("Frame", "WT_greybox", graph, "GarrisonMissionBaseFrameTemplate")
		greybox:SetSize(330, (y_size - 80));
		greybox:SetPoint("CENTER", graph, "CENTER", -10, -5);
		greybox:CreateTexture("WT_Icon_overlay", "ARTWORK");
		WT_Icon_overlay:SetPoint("TOPRIGHT", graph, "TOPRIGHT", 65, 30);
		WT_Icon_overlay:SetTexture("Interface\\ExtraButton\\ChampionLight.blp");
		WT_Icon_overlay:SetSize(160,80);
		greybox:CreateTexture("WT_Icon", "ARTWORK", nil, -1);
		WT_Icon:SetPoint("CENTER", WT_Icon_overlay, "CENTER", 1, 0);
		WT_Icon:SetTexture("Interface\\ICONS\\TEMP.blp");
		WT_Icon:SetSize(32,32);
		
		local scrollframe = CreateFrame("ScrollFrame", nil, greybox)
		scrollframe:SetPoint("TOPLEFT", 10, -10)
		scrollframe:SetPoint("BOTTOMRIGHT", -10, 15)
		greybox.scrollframe = scrollframe
		
		scrollframe:EnableMouseWheel(true);
		scrollframe:SetScript("OnMouseWheel", function(self, delta)
			local bar_value = greybox.scrollbar:GetValue();
			greybox.scrollbar:SetValue(bar_value - (delta * 45));
		end)
		
		local scrollbar = CreateFrame("Slider", nil, scrollframe, "UIPanelScrollBarTemplate")
		scrollbar:SetPoint("TOPLEFT", greybox, "TOPRIGHT", 4, -16)
		scrollbar:SetPoint("BOTTOMLEFT", greybox, "BOTTOMRIGHT", 4, 16)
		scrollbar:SetMinMaxValues(1, 530)
		scrollbar:SetValueStep(1)
		scrollbar.scrollStep = 1
		scrollbar:SetValue(0)
		scrollbar:SetWidth(16)
		scrollbar:SetScript("OnValueChanged",
		function (self, value)
		self:GetParent():SetVerticalScroll(value)
		end)
		local scrollbg = scrollbar:CreateTexture(nil, "BACKGROUND")
		scrollbg:SetAllPoints(scrollbar)
		scrollbg:SetTexture(0, 0, 0, .8)
		greybox.scrollbar = scrollbar
		
		local content = CreateFrame("Frame", "WT_Content", scrollframe)
		content:SetSize(300, 530)
		scrollframe.content = content
		scrollframe:SetScrollChild(content) 
		
		local active_tab = CreateFrame("Button", "WatchtowerTab1", graph, "GarrisonMissionFrameTabTemplate")
		active_tab:SetPoint("TOPLEFT", graph , "BOTTOMLEFT", 15, 0);
		PanelTemplates_DeselectTab(active_tab);
		active_tab:SetText("Active");
		PanelTemplates_TabResize(active_tab, 10);
		PanelTemplates_SelectTab(active_tab);
		
		local inactive_tab = CreateFrame("Button", "WatchtowerTab2", graph, "GarrisonMissionFrameTabTemplate")
		inactive_tab:SetPoint("LEFT", active_tab , "RIGHT", -10, 0);
		PanelTemplates_DeselectTab(inactive_tab);
		inactive_tab:SetText("Inactive");
		PanelTemplates_TabResize(inactive_tab, 10);
		
		
		inactive_tab:SetScript("OnClick", function()	
			PanelTemplates_SelectTab(inactive_tab);
			PanelTemplates_DeselectTab(active_tab);
			WATCHTOWER_FOLLOWER_STATE = "inactive";
			followerSync();
			
		end);
		
		active_tab:SetScript("OnClick", function()	
			PanelTemplates_SelectTab(active_tab);
			PanelTemplates_DeselectTab(inactive_tab);
			WATCHTOWER_FOLLOWER_STATE = "active";
			followerSync();
			
		end);
		for i = 1, #containers do
			local box = CreateFrame("Frame", containers[i].name, content);
			box:SetBackdrop(backdrop);
			box:SetSize(containers[i].x, containers[i].y);
			box:SetPoint(containers[i].self_anchor, containers[i].relativeto, containers[i].parent_anchor, containers[i].x_offset, containers[i].y_offset);
			local title = box:CreateFontString(nil, "ARTWORK", "QuestFontNormalSmall");
			title:SetText("|cffffff00" .. containers[i].title .. "|r");
			title:SetPoint("TOP", 0, -5);
			for index2 = 0,9 do
				local line = box:CreateTexture(nil);
				line:SetTexture(1.0, 1.0, 1.0, 0.1);
				line:SetSize((containers[i].x - 50),1);
				line:SetPoint("BOTTOM", 0, ((index2 * 10) + 30));
				local numleft = box:CreateFontString(nil,"ARTWORK" ,"GameFontNormalSmall");
				local numright = box:CreateFontString(nil,"ARTWORK" ,"GameFontNormalSmall");
				numleft:SetPoint("LEFT", line, "RIGHT", 5, 0);
				numright:SetPoint("RIGHT", line, "LEFT",-5, 0);
				if index2 < 0 then
					numleft:SetText(index2 * (-1));
					numright:SetText(index2 * (-1));
				else
					numleft:SetText(index2);
					numright:SetText(index2);
				end
			end
		end
		
		watchtowerButtons(WatchtowerDB.counters, WT_Counters);
		watchtowerButtons(WatchtowerDB.specials, WT_Duration);
		watchtowerButtons(WatchtowerDB.experience, WT_Experience);
		watchtowerButtons(WatchtowerDB.slayer, WT_Slayer);
		watchtowerButtons(WatchtowerDB.terrain, WT_Terrain);
		watchtowerButtons(WatchtowerDB.profession, WT_Profession);
		if faction == "Alliance" then
			watchtowerButtons(WatchtowerDB.groupa, WT_Group);
		else
			watchtowerButtons(WatchtowerDB.grouph, WT_Group);
		end
		
	end
	
	if watchtowerState == true then
		WT_Graph:Show();
	else
		WT_Graph:Hide();
	end
	
end