local faction = UnitFactionGroup("player");

local frame_table = {};
frame_table.buttons = {};

function watchtower_toggle_button()
	if watchtowerToggle == nil then
		local toggle = CreateFrame("Button", "watchtowerToggle", GarrisonMissionFrame, "UIPanelButtonTemplate");
		toggle:SetSize(100, 20);
		toggle:SetPoint("TOPRIGHT", GarrisonMissionFrame, "TOPRIGHT", -25, 0);
		toggle:SetText("Watchtower");
		toggle:SetScript("OnClick", function(self)
			if watchtowerState == true then
				watchtowerState = false;
				watchtowerFrame();
			else
				watchtowerState = true;
				watchtowerFrame();
			end
			
		end)
	end
end

function watchtowerButtons(trait, data_frame)
	
	for index = 1, #trait do
		
		frame_table.buttons[trait[index].button_name] = CreateFrame("Button", "WT_" .. trait[index].name, data_frame);
		frame_table.buttons[trait[index].button_name]:SetNormalTexture(trait[index].icon);
		frame_table.buttons[trait[index].button_name]:SetSize(18,18);
		frame_table.buttons[trait[index].button_name]:SetPoint(trait[index].self_anchor, trait[index].relativeto, trait[index].parent_anchor, trait[index].x_offset, trait[index].y_offset);
		
		frame_table.buttons[trait[index].button_name]:SetScript("OnClick", function()
				GarrisonMissionFrameTab2:Click();
				GarrisonMissionFrameFollowers.SearchBox:SetText(trait[index].name);
		end)
		frame_table[trait[index].texture_name_active]  = frame_table.buttons[trait[index].button_name]:CreateTexture("WT_" .. trait[index].name .. "_active");
		frame_table[trait[index].texture_name_active]:SetTexture(0.0,0.8,0.0,0.3);
		frame_table[trait[index].texture_name_active]:SetSize(18,90);
		frame_table[trait[index].texture_name_active]:SetPoint("BOTTOM", "WT_" .. trait[index].name, "TOP", 0, 7.5);
		
		frame_table[trait[index].texture_name_inactive] = frame_table.buttons[trait[index].button_name]:CreateTexture("WT_" .. trait[index].name .. "_inactive");
		frame_table[trait[index].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.3);
		frame_table[trait[index].texture_name_inactive]:SetSize(18,90);
		frame_table[trait[index].texture_name_inactive]:SetPoint("BOTTOM", "WT_" .. trait[index].name, "TOP", 0, 7.5);
		
		frame_table[trait[index].name .. "_over"] = CreateFrame("Button", "WT_" .. trait[index].name .. "_over", data_frame);
		frame_table[trait[index].name .. "_over"]:SetNormalTexture("Interface\\PETBATTLES\\BattleBar-AbilityBadge-Strong.blp");
		frame_table[trait[index].name .. "_over"]:SetSize(15,15);
		frame_table[trait[index].name .. "_over"]:SetPoint("BOTTOM", frame_table[trait[index].texture_name_active], "TOP", 0, -1);
	end
end



function followerSync()

	local all_followers = C_Garrison.GetFollowers();
	
	local watchtowerFollowers = {};
	
	for i = 1, #all_followers do
		if all_followers[i].isCollected then
			table.insert(watchtowerFollowers, all_followers[i]);
		end
	end
	
	follower_parse(WatchtowerDB.counters, watchtowerFollowers);
	follower_parse(WatchtowerDB.specials, watchtowerFollowers);
	follower_parse(WatchtowerDB.experience, watchtowerFollowers);
	follower_parse(WatchtowerDB.groupa, watchtowerFollowers);
	follower_parse(WatchtowerDB.grouph, watchtowerFollowers);
	follower_parse(WatchtowerDB.slayer, watchtowerFollowers);
	follower_parse(WatchtowerDB.terrain, watchtowerFollowers);
	follower_parse(WatchtowerDB.profession, watchtowerFollowers);	
				
	watchtowerTooltips(WatchtowerDB.counters);
	watchtowerTooltips(WatchtowerDB.specials);
	watchtowerTooltips(WatchtowerDB.experience);
	watchtowerTooltips(WatchtowerDB.slayer);
	watchtowerTooltips(WatchtowerDB.terrain);
	watchtowerTooltips(WatchtowerDB.profession);
	if faction == "Alliance" then
		watchtowerTooltips(WatchtowerDB.groupa);
	else
		watchtowerTooltips(WatchtowerDB.grouph);
	end

end

function follower_parse(traitList, my_followers)
	for key, trait in pairs(traitList) do
		for k in pairs (trait.active) do
			trait.active[k] = nil
		end -- for
		for k in pairs (trait.inactive) do
			trait.inactive[k] = nil
		end -- for
		for follower = 1, #my_followers do
			local status = my_followers[follower].status;	
			follower_abilities = C_Garrison.GetFollowerAbilities(my_followers[follower].followerID);
			for abilities = 1, #follower_abilities do
				ability = follower_abilities[abilities];
				
				if ability.isTrait then
				
					if ability.name == trait.name then
						if status == "Inactive" then
							trait.inactive[my_followers[follower].name] = my_followers[follower];
						else
							trait.active[my_followers[follower].name] = my_followers[follower];
						end
					end
				else
					for key, value in pairs(ability.counters) do
						if value.name == trait.name then
							if status == "Inactive" then
								trait.inactive[my_followers[follower].name] = my_followers[follower];
							else
								trait.active[my_followers[follower].name] = my_followers[follower];
							end
						end
					end
					
				end
			end
		end
	end
end

function watchtowerTooltips(traits)
	
	local follower_state = WATCHTOWER_FOLLOWER_STATE;
	
	for i = 1, #traits do
		
		if follower_state == "active" then
				
				frame_table[traits[i].name .. "_over"]:Hide();
				frame_table[traits[i].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.0);
				frame_table[traits[i].texture_name_active]:SetTexture(0.0,0.8,0.0,0.3);
				if the_count(traits[i].active) < 1 then
					frame_table[traits[i].texture_name_active]:SetTexture(0.0,0.8,0.0,0.0);
				elseif the_count(traits[i].active) > 9 then
					frame_table[traits[i].texture_name_active]:SetSize(18, 90);
					frame_table[traits[i].name .. "_over"]:Show();
				else
					frame_table[traits[i].texture_name_active]:SetSize(18, the_count(traits[i].active) *10);
				end
			
		elseif follower_state == "inactive" then
				
				frame_table[traits[i].name .. "_over"]:Hide();
				frame_table[traits[i].texture_name_active]:SetTexture(0.8,0.0,0.0,0.0);
				frame_table[traits[i].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.3);
				if the_count(traits[i].inactive) < 1 then
					frame_table[traits[i].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.0);
				elseif the_count(traits[i].inactive) > 9 then
					frame_table[traits[i].texture_name_inactive]:SetSize(18, 90);
				else
					frame_table[traits[i].texture_name_inactive]:SetSize(18, the_count(traits[i].inactive) *10);
				end
			
		end
	
		frame_table.buttons[traits[i].button_name]:SetScript("OnEnter", function(self, motion)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			if follower_state == "active" then
				GameTooltip:SetText(traits[i].name .. "  " .. "("  .. the_count(traits[i].active) .. ")");
			else
				GameTooltip:SetText(traits[i].name .. "  " .. "("  .. the_count(traits[i].inactive) .. ")");
			end
			new_active = {};
			new_inactive = {};
			if follower_state == "active" then
				for key,value in pairs(traits[i].active) do
					table.insert(new_active, value);
				end
				table.sort(new_active, follower_sorting);
				if #new_active ~= 0 then
					GameTooltip:AddDoubleLine(" ", " ");
				end
				wt_tipsy(new_active);
			else
				for key,value in pairs(traits[i].inactive) do
					table.insert(new_inactive, value);
				end
				table.sort(new_inactive, follower_sorting);
				if #new_inactive ~= 0 then
					GameTooltip:AddDoubleLine(" ", " ");
				end
				wt_tipsy(new_inactive);
			end
			GameTooltip:Show();
		end)
		frame_table.buttons[traits[i].button_name]:SetScript("OnLeave", function(self, motion)
			GameTooltip:Hide();
		end);	
	end	
end

function wt_tipsy(tbl)
	for key, value in ipairs(tbl) do
		local status = "";
		if value.status == "Inactive" then
			status = "|cffffffff[|r" .. "|cffff0000Inactive|r" .. "|cffffffff]|r";
		else
			if value.status == nil then
				status = "|cffffffff[|r" .. "|cff1eff00Idle|r"  .. "|cffffffff]|r";
			else
				status = "|cffffffff[|r" .. "|cff1eff00" .. value.status .. "|r"  .. "|cffffffff]|r";
			end
		end
				
		if value.quality == 5 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cffff8000[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cffff8000[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status); 
			end	
		elseif value.quality == 4 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cffa335ee[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cffa335ee[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			end
		elseif value.quality == 3 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cff0070dd[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cff0070dd[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			end
		elseif value.quality == 2 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cff1eff00[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cff1eff00[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			end
		end
	end
end